function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState } from 'react';
import { IntlProvider } from 'react-intl';
import Slider from '.';
import { Box, Input, Number as _Number, Typography } from '../..';
import { secondsToTimeString } from '../../common/utils';
var meta = {
  component: Slider,
  title: 'Molecules / Slider'
};
export default meta;
var Template = function Template(args) {
  var _useState = useState(args.defaultValue),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var handleChange = function handleChange(v) {
    return setValue(v);
  };
  return React.createElement(IntlProvider, {
    locale: "en"
  }, React.createElement(Box, {
    p: 20
  }, React.createElement("div", {
    style: {
      border: '1px solid red'
    }
  }, React.createElement(Slider, _extends({}, args, {
    onChange: handleChange
  }))), React.createElement(Typography, null, React.createElement(_Number, {
    value: value,
    maximumDecimals: 2
  }), " Kronor")));
};
export var Default = {
  render: Template,
  args: {
    defaultValue: 50,
    min: 0,
    max: 100,
    step: 1
  }
};
export var MinimumValue = {
  render: Template,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    defaultValue: 0,
    max: 10
  })
};
export var MaximumValue = {
  render: Template,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    defaultValue: 100,
    min: 50
  })
};
var TemplateMultiColor = function TemplateMultiColor(args) {
  var _useState3 = useState(args.defaultValue),
    _useState4 = _slicedToArray(_useState3, 2),
    value = _useState4[0],
    setValue = _useState4[1];
  var handleChange = function handleChange(v) {
    return setValue(v);
  };
  return React.createElement(IntlProvider, {
    locale: "en"
  }, React.createElement(Box, {
    p: 20
  }, React.createElement(Slider, _extends({}, args, {
    onChange: handleChange,
    sliderColor: function sliderColor(t) {
      return value > 0 ? t.color.positive : t.color.negative;
    }
  })), React.createElement(Typography, null, React.createElement(_Number, {
    value: value,
    maximumDecimals: 2
  }), " Kronor")));
};
export var NegativeToPositive = {
  render: TemplateMultiColor,
  args: {
    defaultValue: 0,
    min: -50,
    max: 50,
    step: 1
  }
};
export var SmallVariant = {
  render: Template,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    variant: 'small'
  })
};
export var ValuesOutsideRange = {
  render: Template,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    defaultValue: -50,
    min: -10,
    max: 10
  })
};
var PlayerTemplate = function PlayerTemplate(args) {
  return React.createElement(Box, {
    p: 20
  }, React.createElement(Slider, args));
};
export var PlayerVariant = {
  render: PlayerTemplate,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    defaultValue: 1800,
    min: 0,
    max: 4000,
    step: 1,
    variant: 'player',
    formatter: secondsToTimeString,
    showTooltip: true
  })
};
export var Disabled = {
  render: Template,
  args: _objectSpread(_objectSpread({}, Default.args), {}, {
    disabled: true
  })
};
var TemplateControlled = function TemplateControlled(args) {
  var start = 50;
  var _useState5 = useState(start),
    _useState6 = _slicedToArray(_useState5, 2),
    value = _useState6[0],
    setValue = _useState6[1];
  var handleChange = function handleChange(v) {
    return setValue(parseInt(v, 10));
  };
  return React.createElement(IntlProvider, {
    locale: "en"
  }, React.createElement(Box, {
    p: 20
  }, React.createElement(Slider, _extends({}, args, {
    value: value
  })), React.createElement(Input.Number, {
    id: "unique-id",
    label: "Controlled from outside",
    defaultValue: start,
    onChange: handleChange,
    min: args.min,
    max: args.max,
    step: args.step
  })));
};
export var Controlled = {
  render: TemplateControlled,
  args: {
    min: 0,
    max: 100,
    step: 1
  }
};